

<!DOCTYPE html>



<head>
    <meta charset="utf-8" />
    <meta name="author" content="Apple Inc." />
    <meta name="viewport" content="width=device-width initial-scale=1" />
    
    <title>Lexical Structure &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css" />
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico" />
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png" />
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png" />
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png" />
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png" />
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png" />
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png" />
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png" />
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png" />
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png" />
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339" /> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1"><a class="reference internal" href="../LanguageGuide/TheBasics.html">Language Guide</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="AboutTheLanguageReference.html">Language Reference</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="AboutTheLanguageReference.html">About the Language Reference</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="LexicalStructure.html#">Lexical Structure</a></li>
<li class="toctree-l2"><a class="reference internal" href="Types.html">Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Expressions.html">Expressions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Statements.html">Statements</a></li>
<li class="toctree-l2"><a class="reference internal" href="Declarations.html">Declarations</a></li>
<li class="toctree-l2"><a class="reference internal" href="Attributes.html">Attributes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Patterns.html">Patterns</a></li>
<li class="toctree-l2"><a class="reference internal" href="GenericParametersAndArguments.html">Generic Parameters and Arguments</a></li>
<li class="toctree-l2"><a class="reference internal" href="zzSummaryOfTheGrammar.html">Summary of the Grammar</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">← Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="LexicalStructure.html#">Lexical Structure</a><ul>
<li><a class="reference internal" href="LexicalStructure.html#ID411">Whitespace and Comments</a></li>
<li><a class="reference internal" href="LexicalStructure.html#ID412">Identifiers</a></li>
<li><a class="reference internal" href="LexicalStructure.html#ID413">Keywords and Punctuation</a></li>
<li><a class="reference internal" href="LexicalStructure.html#ID414">Literals</a><ul>
<li><a class="reference internal" href="LexicalStructure.html#ID415">Integer Literals</a></li>
<li><a class="reference internal" href="LexicalStructure.html#ID416">Floating-Point Literals</a></li>
<li><a class="reference internal" href="LexicalStructure.html#ID417">String Literals</a></li>
</ul>
</li>
<li><a class="reference internal" href="LexicalStructure.html#ID418">Operators</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="lexical-structure">
<h1>Lexical Structure<a class="headerlink" href="LexicalStructure.html#lexical-structure" title="Permalink to this headline"></a></h1>
<p>The <em>lexical structure</em> of Swift describes what sequence of characters form valid tokens of the language. These valid tokens form the lowest-level building blocks of the language and are used to describe the rest of the language in subsequent chapters. A token consists of an identifier, keyword, punctuation, literal, or operator.</p>
<p>In most cases, tokens are generated from the characters of a Swift source file by considering the longest possible substring from the input text, within the constraints of the grammar that are specified below. This behavior is referred to as <em>longest match</em> or <em>maximal munch</em>.</p>
<div class="section" id="ID411">
<h2>Whitespace and Comments<a class="headerlink" href="LexicalStructure.html#ID411" title="Permalink to this headline"></a></h2>
<p>Whitespace has two uses: to separate tokens in the source file and to help determine whether an operator is a prefix or postfix (see <a class="reference internal" href="LexicalStructure.html#ID418"><span class="std std-ref">Operators</span></a>), but is otherwise ignored. The following characters are considered whitespace: space (U+0020), line feed (U+000A), carriage return (U+000D), horizontal tab (U+0009), vertical tab (U+000B), form feed (U+000C) and null (U+0000).</p>
<p>Comments are treated as whitespace by the compiler. Single line comments begin with <code class="docutils literal"><span class="pre">//</span></code> and continue until a line feed (U+000A) or carriage return (U+000D). Multiline comments begin with <code class="docutils literal"><span class="pre">/*</span></code> and end with <code class="docutils literal"><span class="pre">*/</span></code>. Nesting multiline comments is allowed, but the comment markers must be balanced.</p>
<p>Comments can contain additional formatting and markup, as described in <a class="reference external" href="https://developer.apple.com/library/content/documentation/Xcode/Reference/xcode_markup_formatting_ref/index.html">Markup Formatting Reference</a>.</p>
<div class="admonition grammar"><p class="first admonition-title">Grammar of whitespace</p><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/whitespace"></a>whitespace</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/whitespace-item">whitespace-item</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/whitespace">whitespace</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/whitespace-item"></a>whitespace-item</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/line-break">line-break</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/whitespace-item"></a>whitespace-item</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/comment">comment</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/whitespace-item"></a>whitespace-item</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-comment">multiline-comment</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/whitespace-item"></a>whitespace-item</span><span class="arrow"> → </span> U+0000, U+0009, U+000B, U+000C, or U+0020</p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/line-break"></a>line-break</span><span class="arrow"> → </span> U+000A</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/line-break"></a>line-break</span><span class="arrow"> → </span> U+000D</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/line-break"></a>line-break</span><span class="arrow"> → </span> U+000D followed by U+000A</p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/comment"></a>comment</span><span class="arrow"> → </span> <code>//</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/comment-text">comment-text</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/line-break">line-break</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-comment"></a>multiline-comment</span><span class="arrow"> → </span> <code>/*</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-comment-text">multiline-comment-text</a></span>  <code>*/</code></p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/comment-text"></a>comment-text</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/comment-text-item">comment-text-item</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/comment-text">comment-text</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/comment-text-item"></a>comment-text-item</span><span class="arrow"> → </span> Any Unicode scalar value except U+000A or U+000D</p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-comment-text"></a>multiline-comment-text</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-comment-text-item">multiline-comment-text-item</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-comment-text">multiline-comment-text</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-comment-text-item"></a>multiline-comment-text-item</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-comment">multiline-comment</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-comment-text-item"></a>multiline-comment-text-item</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/comment-text-item">comment-text-item</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-comment-text-item"></a>multiline-comment-text-item</span><span class="arrow"> → </span> Any Unicode scalar value except  <code>/*</code> or  <code>*/</code></p></div></div></div>
<div class="section" id="ID412">
<h2>Identifiers<a class="headerlink" href="LexicalStructure.html#ID412" title="Permalink to this headline"></a></h2>
<p><em>Identifiers</em> begin with an uppercase or lowercase letter A through Z, an underscore (<code class="docutils literal"><span class="pre">_</span></code>), a noncombining alphanumeric Unicode character in the Basic Multilingual Plane, or a character outside the Basic Multilingual Plane that isn’t in a Private Use Area. After the first character, digits and combining Unicode characters are also allowed.</p>
<p>To use a reserved word as an identifier, put a backtick (<code class="docutils literal"><span class="pre">`</span></code>) before and after it. For example, <code class="docutils literal"><span class="pre">class</span></code> is not a valid identifier, but <code class="docutils literal"><span class="pre">`class`</span></code> is valid. The backticks aren’t considered part of the identifier; <code class="docutils literal"><span class="pre">`x`</span></code> and <code class="docutils literal"><span class="pre">x</span></code> have the same meaning.</p>
<p>Inside a closure with no explicit parameter names, the parameters are implicitly named <code class="docutils literal"><span class="pre">$0</span></code>, <code class="docutils literal"><span class="pre">$1</span></code>, <code class="docutils literal"><span class="pre">$2</span></code>, and so on. These names are valid identifiers within the scope of the closure.</p>
<div class="admonition grammar"><p class="first admonition-title">Grammar of an identifier</p><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier"></a>identifier</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/identifier-head">identifier-head</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/identifier-characters">identifier-characters</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier"></a>identifier</span><span class="arrow"> → </span> <code>`</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/identifier-head">identifier-head</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/identifier-characters">identifier-characters</a></span> <sub>opt</sub> <code>`</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier"></a>identifier</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/implicit-parameter-name">implicit-parameter-name</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-list"></a>identifier-list</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/identifier">identifier</a></span>  |  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/identifier">identifier</a></span>  <code>,</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/identifier-list">identifier-list</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> Upper- or lowercase letter A through Z</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> <code>_</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+00A8, U+00AA, U+00AD, U+00AF, U+00B2–U+00B5, or U+00B7–U+00BA</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+00BC–U+00BE, U+00C0–U+00D6, U+00D8–U+00F6, or U+00F8–U+00FF</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+0100–U+02FF, U+0370–U+167F, U+1681–U+180D, or U+180F–U+1DBF</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+1E00–U+1FFF</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+200B–U+200D, U+202A–U+202E, U+203F–U+2040, U+2054, or U+2060–U+206F</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+2070–U+20CF, U+2100–U+218F, U+2460–U+24FF, or U+2776–U+2793</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+2C00–U+2DFF or U+2E80–U+2FFF</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+3004–U+3007, U+3021–U+302F, U+3031–U+303F, or U+3040–U+D7FF</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+F900–U+FD3D, U+FD40–U+FDCF, U+FDF0–U+FE1F, or U+FE30–U+FE44</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+FE47–U+FFFD</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+10000–U+1FFFD, U+20000–U+2FFFD, U+30000–U+3FFFD, or U+40000–U+4FFFD</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+50000–U+5FFFD, U+60000–U+6FFFD, U+70000–U+7FFFD, or U+80000–U+8FFFD</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+90000–U+9FFFD, U+A0000–U+AFFFD, U+B0000–U+BFFFD, or U+C0000–U+CFFFD</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-head"></a>identifier-head</span><span class="arrow"> → </span> U+D0000–U+DFFFD or U+E0000–U+EFFFD</p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-character"></a>identifier-character</span><span class="arrow"> → </span> Digit 0 through 9</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-character"></a>identifier-character</span><span class="arrow"> → </span> U+0300–U+036F, U+1DC0–U+1DFF, U+20D0–U+20FF, or U+FE20–U+FE2F</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-character"></a>identifier-character</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/identifier-head">identifier-head</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/identifier-characters"></a>identifier-characters</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/identifier-character">identifier-character</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/identifier-characters">identifier-characters</a></span> <sub>opt</sub></p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/implicit-parameter-name"></a>implicit-parameter-name</span><span class="arrow"> → </span> <code>$</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-digits">decimal-digits</a></span> </p></div></div></div>
<div class="section" id="ID413">
<h2>Keywords and Punctuation<a class="headerlink" href="LexicalStructure.html#ID413" title="Permalink to this headline"></a></h2>
<p>The following keywords are reserved and can’t be used as identifiers, unless they’re escaped with backticks, as described above in <a class="reference internal" href="LexicalStructure.html#lexicalstructure-identifiers"><span class="std std-ref">Identifiers</span></a>. Keywords other than <code class="docutils literal"><span class="pre">inout</span></code>, <code class="docutils literal"><span class="pre">var</span></code>, and <code class="docutils literal"><span class="pre">let</span></code> can be used as parameter names in a function declaration or function call without being escaped with backticks. When a member has the same name as a keyword, references to that member don’t need to be escaped with backticks, except when there’s ambiguity between referring to the member and using the keyword—for example, <code class="docutils literal"><span class="pre">self</span></code>, <code class="docutils literal"><span class="pre">Type</span></code>, and <code class="docutils literal"><span class="pre">Protocol</span></code> have special meaning in an explicit member expression, so they must be escaped with backticks in that context.</p>
<ul class="simple">
<li>Keywords used in declarations: <code class="docutils literal"><span class="pre">associatedtype</span></code>, <code class="docutils literal"><span class="pre">class</span></code>, <code class="docutils literal"><span class="pre">deinit</span></code>, <code class="docutils literal"><span class="pre">enum</span></code>, <code class="docutils literal"><span class="pre">extension</span></code>, <code class="docutils literal"><span class="pre">fileprivate</span></code>, <code class="docutils literal"><span class="pre">func</span></code>, <code class="docutils literal"><span class="pre">import</span></code>, <code class="docutils literal"><span class="pre">init</span></code>, <code class="docutils literal"><span class="pre">inout</span></code>, <code class="docutils literal"><span class="pre">internal</span></code>, <code class="docutils literal"><span class="pre">let</span></code>, <code class="docutils literal"><span class="pre">open</span></code>, <code class="docutils literal"><span class="pre">operator</span></code>, <code class="docutils literal"><span class="pre">private</span></code>, <code class="docutils literal"><span class="pre">protocol</span></code>, <code class="docutils literal"><span class="pre">public</span></code>, <code class="docutils literal"><span class="pre">static</span></code>, <code class="docutils literal"><span class="pre">struct</span></code>, <code class="docutils literal"><span class="pre">subscript</span></code>, <code class="docutils literal"><span class="pre">typealias</span></code>, and <code class="docutils literal"><span class="pre">var</span></code>.</li>
<li>Keywords used in statements: <code class="docutils literal"><span class="pre">break</span></code>, <code class="docutils literal"><span class="pre">case</span></code>, <code class="docutils literal"><span class="pre">continue</span></code>, <code class="docutils literal"><span class="pre">default</span></code>, <code class="docutils literal"><span class="pre">defer</span></code>, <code class="docutils literal"><span class="pre">do</span></code>, <code class="docutils literal"><span class="pre">else</span></code>, <code class="docutils literal"><span class="pre">fallthrough</span></code>, <code class="docutils literal"><span class="pre">for</span></code>, <code class="docutils literal"><span class="pre">guard</span></code>, <code class="docutils literal"><span class="pre">if</span></code>, <code class="docutils literal"><span class="pre">in</span></code>, <code class="docutils literal"><span class="pre">repeat</span></code>, <code class="docutils literal"><span class="pre">return</span></code>, <code class="docutils literal"><span class="pre">switch</span></code>, <code class="docutils literal"><span class="pre">where</span></code>, and <code class="docutils literal"><span class="pre">while</span></code>.</li>
<li>Keywords used in expressions and types: <code class="docutils literal"><span class="pre">as</span></code>, <code class="docutils literal"><span class="pre">Any</span></code>, <code class="docutils literal"><span class="pre">catch</span></code>, <code class="docutils literal"><span class="pre">false</span></code>, <code class="docutils literal"><span class="pre">is</span></code>, <code class="docutils literal"><span class="pre">nil</span></code>, <code class="docutils literal"><span class="pre">rethrows</span></code>, <code class="docutils literal"><span class="pre">super</span></code>, <code class="docutils literal"><span class="pre">self</span></code>, <code class="docutils literal"><span class="pre">Self</span></code>, <code class="docutils literal"><span class="pre">throw</span></code>, <code class="docutils literal"><span class="pre">throws</span></code>, <code class="docutils literal"><span class="pre">true</span></code>, and <code class="docutils literal"><span class="pre">try</span></code>.</li>
<li>Keywords used in patterns: <code class="docutils literal"><span class="pre">_</span></code>.</li>
<li>Keywords that begin with a number sign (<code class="docutils literal"><span class="pre">#</span></code>): <code class="docutils literal"><span class="pre">#available</span></code>, <code class="docutils literal"><span class="pre">#colorLiteral</span></code>, <code class="docutils literal"><span class="pre">#column</span></code>, <code class="docutils literal"><span class="pre">#else</span></code>, <code class="docutils literal"><span class="pre">#elseif</span></code>, <code class="docutils literal"><span class="pre">#endif</span></code>, <code class="docutils literal"><span class="pre">#error</span></code>, <code class="docutils literal"><span class="pre">#file</span></code>, <code class="docutils literal"><span class="pre">#fileLiteral</span></code>, <code class="docutils literal"><span class="pre">#function</span></code>, <code class="docutils literal"><span class="pre">#if</span></code>, <code class="docutils literal"><span class="pre">#imageLiteral</span></code>, <code class="docutils literal"><span class="pre">#line</span></code>, <code class="docutils literal"><span class="pre">#selector</span></code>, <code class="docutils literal"><span class="pre">#sourceLocation</span></code>, and <code class="docutils literal"><span class="pre">#warning</span></code>.</li>
</ul>
<ul class="simple">
<li>Keywords reserved in particular contexts: <code class="docutils literal"><span class="pre">associativity</span></code>, <code class="docutils literal"><span class="pre">convenience</span></code>, <code class="docutils literal"><span class="pre">dynamic</span></code>, <code class="docutils literal"><span class="pre">didSet</span></code>, <code class="docutils literal"><span class="pre">final</span></code>, <code class="docutils literal"><span class="pre">get</span></code>, <code class="docutils literal"><span class="pre">infix</span></code>, <code class="docutils literal"><span class="pre">indirect</span></code>, <code class="docutils literal"><span class="pre">lazy</span></code>, <code class="docutils literal"><span class="pre">left</span></code>, <code class="docutils literal"><span class="pre">mutating</span></code>, <code class="docutils literal"><span class="pre">none</span></code>, <code class="docutils literal"><span class="pre">nonmutating</span></code>, <code class="docutils literal"><span class="pre">optional</span></code>, <code class="docutils literal"><span class="pre">override</span></code>, <code class="docutils literal"><span class="pre">postfix</span></code>, <code class="docutils literal"><span class="pre">precedence</span></code>, <code class="docutils literal"><span class="pre">prefix</span></code>, <code class="docutils literal"><span class="pre">Protocol</span></code>, <code class="docutils literal"><span class="pre">required</span></code>, <code class="docutils literal"><span class="pre">right</span></code>, <code class="docutils literal"><span class="pre">set</span></code>, <code class="docutils literal"><span class="pre">Type</span></code>, <code class="docutils literal"><span class="pre">unowned</span></code>, <code class="docutils literal"><span class="pre">weak</span></code>, and <code class="docutils literal"><span class="pre">willSet</span></code>. Outside the context in which they appear in the grammar, they can be used as identifiers.</li>
</ul>
<p>The following tokens are reserved as punctuation and can’t be used as custom operators: <code class="docutils literal"><span class="pre">(</span></code>, <code class="docutils literal"><span class="pre">)</span></code>, <code class="docutils literal"><span class="pre">{</span></code>, <code class="docutils literal"><span class="pre">}</span></code>, <code class="docutils literal"><span class="pre">[</span></code>, <code class="docutils literal"><span class="pre">]</span></code>, <code class="docutils literal"><span class="pre">.</span></code>, <code class="docutils literal"><span class="pre">,</span></code>, <code class="docutils literal"><span class="pre">:</span></code>, <code class="docutils literal"><span class="pre">;</span></code>, <code class="docutils literal"><span class="pre">=</span></code>, <code class="docutils literal"><span class="pre">&#64;</span></code>, <code class="docutils literal"><span class="pre">#</span></code>, <code class="docutils literal"><span class="pre">&amp;</span></code> (as a prefix operator), <code class="docutils literal"><span class="pre">-&gt;</span></code>, <code class="docutils literal"><span class="pre">`</span></code>, <code class="docutils literal"><span class="pre">?</span></code>, and <code class="docutils literal"><span class="pre">!</span></code> (as a postfix operator).</p>
</div>
<div class="section" id="ID414">
<h2>Literals<a class="headerlink" href="LexicalStructure.html#ID414" title="Permalink to this headline"></a></h2>
<p>A <em>literal</em> is the source code representation of a value of a type, such as a number or string.</p>
<p>The following are examples of literals:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="m">42</span>               <span class="c">// Integer literal</span>
</li><li><span class="m">3.14159</span>          <span class="c">// Floating-point literal</span>
</li><li><span class="s">&quot;Hello, world!&quot;</span>  <span class="c">// String literal</span>
</li><li><span class="k">true</span>             <span class="c">// Boolean literal</span>
</li></ol></pre></div></div>
<p>A literal doesn’t have a type on its own. Instead, a literal is parsed as having infinite precision and Swift’s type inference attempts to infer a type for the literal. For example, in the declaration <code class="docutils literal"><span class="pre">let</span> <span class="pre">x:</span> <span class="pre">Int8</span> <span class="pre">=</span> <span class="pre">42</span></code>, Swift uses the explicit type annotation (<code class="docutils literal"><span class="pre">:</span> <span class="pre">Int8</span></code>) to infer that the type of the integer literal <code class="docutils literal"><span class="pre">42</span></code> is <code class="docutils literal"><span class="pre">Int8</span></code>. If there isn’t suitable type information available, Swift infers that the literal’s type is one of the default literal types defined in the Swift standard library. The default types are <code class="docutils literal"><span class="pre">Int</span></code> for integer literals, <code class="docutils literal"><span class="pre">Double</span></code> for floating-point literals, <code class="docutils literal"><span class="pre">String</span></code> for string literals, and <code class="docutils literal"><span class="pre">Bool</span></code> for Boolean literals. For example, in the declaration <code class="docutils literal"><span class="pre">let</span> <span class="pre">str</span> <span class="pre">=</span> <span class="pre">&quot;Hello,</span> <span class="pre">world&quot;</span></code>, the default inferred type of the string literal <code class="docutils literal"><span class="pre">&quot;Hello,</span> <span class="pre">world&quot;</span></code> is <code class="docutils literal"><span class="pre">String</span></code>.</p>
<p>When specifying the type annotation for a literal value, the annotation’s type must be a type that can be instantiated from that literal value. That is, the type must conform to one of the following Swift standard library protocols: <code class="docutils literal"><span class="pre">ExpressibleByIntegerLiteral</span></code> for integer literals, <code class="docutils literal"><span class="pre">ExpressibleByFloatLiteral</span></code> for floating-point literals, <code class="docutils literal"><span class="pre">ExpressibleByStringLiteral</span></code> for string literals, <code class="docutils literal"><span class="pre">ExpressibleByBooleanLiteral</span></code> for Boolean literals, <code class="docutils literal"><span class="pre">ExpressibleByUnicodeScalarLiteral</span></code> for string literals that contain only a single Unicode scalar, and <code class="docutils literal"><span class="pre">ExpressibleByExtendedGraphemeClusterLiteral</span></code> for string literals that contain only a single extended grapheme cluster. For example, <code class="docutils literal"><span class="pre">Int8</span></code> conforms to the <code class="docutils literal"><span class="pre">ExpressibleByIntegerLiteral</span></code> protocol, and therefore it can be used in the type annotation for the integer literal <code class="docutils literal"><span class="pre">42</span></code> in the declaration <code class="docutils literal"><span class="pre">let</span> <span class="pre">x:</span> <span class="pre">Int8</span> <span class="pre">=</span> <span class="pre">42</span></code>.</p>
<div class="admonition grammar"><p class="first admonition-title">Grammar of a literal</p><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/literal"></a>literal</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/numeric-literal">numeric-literal</a></span>  |  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/string-literal">string-literal</a></span>  |  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/boolean-literal">boolean-literal</a></span>  |  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/nil-literal">nil-literal</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/numeric-literal"></a>numeric-literal</span><span class="arrow"> → </span> <code>-</code><sub>opt</sub> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/integer-literal">integer-literal</a></span>  |  <code>-</code><sub>opt</sub> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/floating-point-literal">floating-point-literal</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/boolean-literal"></a>boolean-literal</span><span class="arrow"> → </span> <code>true</code> |  <code>false</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/nil-literal"></a>nil-literal</span><span class="arrow"> → </span> <code>nil</code></p></div></div><div class="section" id="ID415">
<h3>Integer Literals<a class="headerlink" href="LexicalStructure.html#ID415" title="Permalink to this headline"></a></h3>
<p><em>Integer literals</em> represent integer values of unspecified precision. By default, integer literals are expressed in decimal; you can specify an alternate base using a prefix. Binary literals begin with <code class="docutils literal"><span class="pre">0b</span></code>, octal literals begin with <code class="docutils literal"><span class="pre">0o</span></code>, and hexadecimal literals begin with <code class="docutils literal"><span class="pre">0x</span></code>.</p>
<p>Decimal literals contain the digits <code class="docutils literal"><span class="pre">0</span></code> through <code class="docutils literal"><span class="pre">9</span></code>. Binary literals contain <code class="docutils literal"><span class="pre">0</span></code> and <code class="docutils literal"><span class="pre">1</span></code>, octal literals contain <code class="docutils literal"><span class="pre">0</span></code> through <code class="docutils literal"><span class="pre">7</span></code>, and hexadecimal literals contain <code class="docutils literal"><span class="pre">0</span></code> through <code class="docutils literal"><span class="pre">9</span></code> as well as <code class="docutils literal"><span class="pre">A</span></code> through <code class="docutils literal"><span class="pre">F</span></code> in upper- or lowercase.</p>
<p>Negative integers literals are expressed by prepending a minus sign (<code class="docutils literal"><span class="pre">-</span></code>) to an integer literal, as in <code class="docutils literal"><span class="pre">-42</span></code>.</p>
<p>Underscores (<code class="docutils literal"><span class="pre">_</span></code>) are allowed between digits for readability, but they’re ignored and therefore don’t affect the value of the literal. Integer literals can begin with leading zeros (<code class="docutils literal"><span class="pre">0</span></code>), but they’re likewise ignored and don’t affect the base or value of the literal.</p>
<p>Unless otherwise specified, the default inferred type of an integer literal is the Swift standard library type <code class="docutils literal"><span class="pre">Int</span></code>. The Swift standard library also defines types for various sizes of signed and unsigned integers, as described in <a class="reference internal" href="../LanguageGuide/TheBasics.html#ID317"><span class="std std-ref">Integers</span></a>.</p>
<div class="admonition grammar"><p class="first admonition-title">Grammar of an integer literal</p><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/integer-literal"></a>integer-literal</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/binary-literal">binary-literal</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/integer-literal"></a>integer-literal</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/octal-literal">octal-literal</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/integer-literal"></a>integer-literal</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-literal">decimal-literal</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/integer-literal"></a>integer-literal</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-literal">hexadecimal-literal</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/binary-literal"></a>binary-literal</span><span class="arrow"> → </span> <code>0b</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/binary-digit">binary-digit</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/binary-literal-characters">binary-literal-characters</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/binary-digit"></a>binary-digit</span><span class="arrow"> → </span> Digit 0 or 1</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/binary-literal-character"></a>binary-literal-character</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/binary-digit">binary-digit</a></span>  |  <code>_</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/binary-literal-characters"></a>binary-literal-characters</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/binary-literal-character">binary-literal-character</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/binary-literal-characters">binary-literal-characters</a></span> <sub>opt</sub></p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/octal-literal"></a>octal-literal</span><span class="arrow"> → </span> <code>0o</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/octal-digit">octal-digit</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/octal-literal-characters">octal-literal-characters</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/octal-digit"></a>octal-digit</span><span class="arrow"> → </span> Digit 0 through 7</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/octal-literal-character"></a>octal-literal-character</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/octal-digit">octal-digit</a></span>  |  <code>_</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/octal-literal-characters"></a>octal-literal-characters</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/octal-literal-character">octal-literal-character</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/octal-literal-characters">octal-literal-characters</a></span> <sub>opt</sub></p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/decimal-literal"></a>decimal-literal</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-digit">decimal-digit</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-literal-characters">decimal-literal-characters</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/decimal-digit"></a>decimal-digit</span><span class="arrow"> → </span> Digit 0 through 9</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/decimal-digits"></a>decimal-digits</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-digit">decimal-digit</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-digits">decimal-digits</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/decimal-literal-character"></a>decimal-literal-character</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-digit">decimal-digit</a></span>  |  <code>_</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/decimal-literal-characters"></a>decimal-literal-characters</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-literal-character">decimal-literal-character</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-literal-characters">decimal-literal-characters</a></span> <sub>opt</sub></p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/hexadecimal-literal"></a>hexadecimal-literal</span><span class="arrow"> → </span> <code>0x</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-digit">hexadecimal-digit</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-literal-characters">hexadecimal-literal-characters</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/hexadecimal-digit"></a>hexadecimal-digit</span><span class="arrow"> → </span> Digit 0 through 9, a through f, or A through F</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/hexadecimal-literal-character"></a>hexadecimal-literal-character</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-digit">hexadecimal-digit</a></span>  |  <code>_</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/hexadecimal-literal-characters"></a>hexadecimal-literal-characters</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-literal-character">hexadecimal-literal-character</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-literal-characters">hexadecimal-literal-characters</a></span> <sub>opt</sub></p></div></div></div>
<div class="section" id="ID416">
<h3>Floating-Point Literals<a class="headerlink" href="LexicalStructure.html#ID416" title="Permalink to this headline"></a></h3>
<p><em>Floating-point literals</em> represent floating-point values of unspecified precision.</p>
<p>By default, floating-point literals are expressed in decimal (with no prefix), but they can also be expressed in hexadecimal (with a <code class="docutils literal"><span class="pre">0x</span></code> prefix).</p>
<p>Decimal floating-point literals consist of a sequence of decimal digits followed by either a decimal fraction, a decimal exponent, or both. The decimal fraction consists of a decimal point (<code class="docutils literal"><span class="pre">.</span></code>) followed by a sequence of decimal digits. The exponent consists of an upper- or lowercase <code class="docutils literal"><span class="pre">e</span></code> prefix followed by a sequence of decimal digits that indicates what power of 10 the value preceding the <code class="docutils literal"><span class="pre">e</span></code> is multiplied by. For example, <code class="docutils literal"><span class="pre">1.25e2</span></code> represents 1.25 x 10<sup>2</sup>, which evaluates to <code class="docutils literal"><span class="pre">125.0</span></code>. Similarly, <code class="docutils literal"><span class="pre">1.25e-2</span></code> represents 1.25 x 10<sup>-2</sup>, which evaluates to <code class="docutils literal"><span class="pre">0.0125</span></code>.</p>
<p>Hexadecimal floating-point literals consist of a <code class="docutils literal"><span class="pre">0x</span></code> prefix, followed by an optional hexadecimal fraction, followed by a hexadecimal exponent. The hexadecimal fraction consists of a decimal point followed by a sequence of hexadecimal digits. The exponent consists of an upper- or lowercase <code class="docutils literal"><span class="pre">p</span></code> prefix followed by a sequence of decimal digits that indicates what power of 2 the value preceding the <code class="docutils literal"><span class="pre">p</span></code> is multiplied by. For example, <code class="docutils literal"><span class="pre">0xFp2</span></code> represents 15 x 2<sup>2</sup>, which evaluates to <code class="docutils literal"><span class="pre">60</span></code>. Similarly, <code class="docutils literal"><span class="pre">0xFp-2</span></code> represents 15 x 2<sup>-2</sup>, which evaluates to <code class="docutils literal"><span class="pre">3.75</span></code>.</p>
<p>Negative floating-point literals are expressed by prepending a minus sign (<code class="docutils literal"><span class="pre">-</span></code>) to a floating-point literal, as in <code class="docutils literal"><span class="pre">-42.5</span></code>.</p>
<p>Underscores (<code class="docutils literal"><span class="pre">_</span></code>) are allowed between digits for readability, but are ignored and therefore don’t affect the value of the literal. Floating-point literals can begin with leading zeros (<code class="docutils literal"><span class="pre">0</span></code>), but are likewise ignored and don’t affect the base or value of the literal.</p>
<p>Unless otherwise specified, the default inferred type of a floating-point literal is the Swift standard library type <code class="docutils literal"><span class="pre">Double</span></code>, which represents a 64-bit floating-point number. The Swift standard library also defines a <code class="docutils literal"><span class="pre">Float</span></code> type, which represents a 32-bit floating-point number.</p>
<div class="admonition grammar"><p class="first admonition-title">Grammar of a floating-point literal</p><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/floating-point-literal"></a>floating-point-literal</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-literal">decimal-literal</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-fraction">decimal-fraction</a></span> <sub>opt</sub> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-exponent">decimal-exponent</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/floating-point-literal"></a>floating-point-literal</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-literal">hexadecimal-literal</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-fraction">hexadecimal-fraction</a></span> <sub>opt</sub> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-exponent">hexadecimal-exponent</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/decimal-fraction"></a>decimal-fraction</span><span class="arrow"> → </span> <code>.</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-literal">decimal-literal</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/decimal-exponent"></a>decimal-exponent</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/floating-point-e">floating-point-e</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/sign">sign</a></span> <sub>opt</sub> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-literal">decimal-literal</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/hexadecimal-fraction"></a>hexadecimal-fraction</span><span class="arrow"> → </span> <code>.</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-digit">hexadecimal-digit</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/hexadecimal-literal-characters">hexadecimal-literal-characters</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/hexadecimal-exponent"></a>hexadecimal-exponent</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/floating-point-p">floating-point-p</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/sign">sign</a></span> <sub>opt</sub> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/decimal-literal">decimal-literal</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/floating-point-e"></a>floating-point-e</span><span class="arrow"> → </span> <code>e</code> |  <code>E</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/floating-point-p"></a>floating-point-p</span><span class="arrow"> → </span> <code>p</code> |  <code>P</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/sign"></a>sign</span><span class="arrow"> → </span> <code>+</code> |  <code>-</code></p></div></div></div>
<div class="section" id="ID417">
<h3>String Literals<a class="headerlink" href="LexicalStructure.html#ID417" title="Permalink to this headline"></a></h3>
<p>A string literal is a sequence of characters surrounded by quotation marks. A single-line string literal is surrounded by double quotation marks and has the following form:</p>
<div class="syntax-outline highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="s">&quot;</span><span class="gi">characters</span><span class="s">&quot;</span>
</li></ol></pre></div></div>
<p>String literals can’t contain an unescaped double quotation mark (<code class="docutils literal"><span class="pre">&quot;</span></code>), an unescaped backslash (<code class="docutils literal"><span class="pre">\</span></code>), a carriage return, or a line feed.</p>
<p>A multiline string literal is surrounded by three double quotation marks and has the following form:</p>
<div class="syntax-outline highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="s">&quot;&quot;&quot;</span>
</li><li><span class="gi">characters</span><span class="s"></span>
</li><li><span class="s">&quot;&quot;&quot;</span>
</li></ol></pre></div></div>
<p>Unlike a single-line string literal, a multiline string literal can contain unescaped double quotation marks (<code class="docutils literal"><span class="pre">&quot;</span></code>), carriage returns, and line feeds. It can’t contain three unescaped double quotation marks next to each other.</p>
<p>The line break after the <code class="docutils literal"><span class="pre">&quot;&quot;&quot;</span></code> that begins the multiline string literal is not part of the string. The line break before the <code class="docutils literal"><span class="pre">&quot;&quot;&quot;</span></code> that ends the literal is also not part of the string. To make a multiline string literal that begins or ends with a line feed, write a blank line as its first or last line.</p>
<p>A multiline string literal can be indented using any combination of spaces and tabs; this indentation is not included in the string. The <code class="docutils literal"><span class="pre">&quot;&quot;&quot;</span></code> that ends the literal determines the indentation: Every nonblank line in the literal must begin with exactly the same indentation that appears before the closing <code class="docutils literal"><span class="pre">&quot;&quot;&quot;</span></code>; there’s no conversion between tabs and spaces. You can include additional spaces and tabs after that indentation; those spaces and tabs appear in the string.</p>
<p>Line breaks in a multiline string literal are normalized to use the line feed character. Even if your source file has a mix of carriage returns and line feeds, all of the line breaks in the string will be the same.</p>
<p>In a multiline string literal, writing a backslash (<code class="docutils literal"><span class="pre">\</span></code>) at the end of a line omits that line break from the string. Any whitespace between the backslash and the line break is also omitted. You can use this syntax to hard wrap a multiline string literal in your source code, without changing the value of the resulting string.</p>
<p>Special characters can be included in string literals of both the single-line and multiline forms using the following escape sequences:</p>
<ul class="simple">
<li>Null character (<code class="docutils literal"><span class="pre">\0</span></code>)</li>
<li>Backslash (<code class="docutils literal"><span class="pre">\\</span></code>)</li>
<li>Horizontal tab (<code class="docutils literal"><span class="pre">\t</span></code>)</li>
<li>Line feed (<code class="docutils literal"><span class="pre">\n</span></code>)</li>
<li>Carriage return (<code class="docutils literal"><span class="pre">\r</span></code>)</li>
<li>Double quotation mark (<code class="docutils literal"><span class="pre">\&quot;</span></code>)</li>
<li>Single quotation mark (<code class="docutils literal"><span class="pre">\'</span></code>)</li>
<li>Unicode scalar (<code class="docutils literal"><span class="pre">\u{</span></code><em>n</em><code class="docutils literal"><span class="pre">}</span></code>), where <em>n</em> is a hexadecimal number that has one to eight digits</li>
</ul>
<p>The value of an expression can be inserted into a string literal by placing the expression in parentheses after a backslash (<code class="docutils literal"><span class="pre">\</span></code>). The interpolated expression can contain a string literal, but can’t contain an unescaped backslash, a carriage return, or a line feed.</p>
<p>For example, all of the following string literals have the same value:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="s">&quot;1 2 3&quot;</span>
</li><li><span class="s">&quot;1 2 </span>\<span class="p">(</span><span class="s">&quot;3&quot;</span><span class="p">)</span><span class="s">&quot;</span>
</li><li><span class="s">&quot;1 2 </span>\<span class="p">(</span><span class="m">3</span><span class="p">)</span><span class="s">&quot;</span>
</li><li><span class="s">&quot;1 2 </span>\<span class="p">(</span><span class="m">1</span> + <span class="m">2</span><span class="p">)</span><span class="s">&quot;</span>
</li><li><span class="k">let</span> <span class="nv">x</span> = <span class="m">3</span>; <span class="s">&quot;1 2 </span>\<span class="p">(</span><span class="nv">x</span><span class="p">)</span><span class="s">&quot;</span>
</li></ol></pre></div></div>
<p>The default inferred type of a string literal is <code class="docutils literal"><span class="pre">String</span></code>. For more information about the <code class="docutils literal"><span class="pre">String</span></code> type, see <a class="reference internal" href="../LanguageGuide/StringsAndCharacters.html"><span class="doc">Strings and Characters</span></a> and <a class="reference external" href="https://developer.apple.com/documentation/swift/string"><code class="docutils literal"><span class="pre">String</span></code></a>.</p>
<p>String literals that are concatenated by the <code class="docutils literal"><span class="pre">+</span></code> operator are concatenated at compile time. For example, the values of <code class="docutils literal"><span class="pre">textA</span></code> and <code class="docutils literal"><span class="pre">textB</span></code> in the example below are identical—no runtime concatenation is performed.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">textA</span> = <span class="s">&quot;Hello &quot;</span> + <span class="s">&quot;world&quot;</span>
</li><li><span class="k">let</span> <span class="nv">textB</span> = <span class="s">&quot;Hello world&quot;</span>
</li></ol></pre></div></div>
<div class="admonition grammar"><p class="first admonition-title">Grammar of a string literal</p><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/string-literal"></a>string-literal</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/static-string-literal">static-string-literal</a></span>  |  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/interpolated-string-literal">interpolated-string-literal</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/static-string-literal"></a>static-string-literal</span><span class="arrow"> → </span> <code>&quot;</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/quoted-text">quoted-text</a></span> <sub>opt</sub> <code>&quot;</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/static-string-literal"></a>static-string-literal</span><span class="arrow"> → </span> <code>&quot;&quot;&quot;</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-quoted-text">multiline-quoted-text</a></span> <sub>opt</sub> <code>&quot;&quot;&quot;</code></p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/quoted-text"></a>quoted-text</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/quoted-text-item">quoted-text-item</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/quoted-text">quoted-text</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/quoted-text-item"></a>quoted-text-item</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/escaped-character">escaped-character</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/quoted-text-item"></a>quoted-text-item</span><span class="arrow"> → </span> Any Unicode scalar value except  <code>&quot;</code>,  <code>\</code>, U+000A, or U+000D</p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-quoted-text"></a>multiline-quoted-text</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-quoted-text-item">multiline-quoted-text-item</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-quoted-text">multiline-quoted-text</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-quoted-text-item"></a>multiline-quoted-text-item</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/escaped-character">escaped-character</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-quoted-text-item"></a>multiline-quoted-text-item</span><span class="arrow"> → </span> Any Unicode scalar value except  <code>\</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-quoted-text-item"></a>multiline-quoted-text-item</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/escaped-newline">escaped-newline</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/interpolated-string-literal"></a>interpolated-string-literal</span><span class="arrow"> → </span> <code>&quot;</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/interpolated-text">interpolated-text</a></span> <sub>opt</sub> <code>&quot;</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/interpolated-string-literal"></a>interpolated-string-literal</span><span class="arrow"> → </span> <code>&quot;&quot;&quot;</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-interpolated-text">multiline-interpolated-text</a></span> <sub>opt</sub> <code>&quot;&quot;&quot;</code></p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/interpolated-text"></a>interpolated-text</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/interpolated-text-item">interpolated-text-item</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/interpolated-text">interpolated-text</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/interpolated-text-item"></a>interpolated-text-item</span><span class="arrow"> → </span> <code>\(</code> <span class="syntactic-category"><a href="Expressions.html#//appleref/swift/grammar/expression">expression</a></span>  <code>)</code> |  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/quoted-text-item">quoted-text-item</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-interpolated-text"></a>multiline-interpolated-text</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-interpolated-text-item">multiline-interpolated-text-item</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-interpolated-text">multiline-interpolated-text</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/multiline-interpolated-text-item"></a>multiline-interpolated-text-item</span><span class="arrow"> → </span> <code>\(</code> <span class="syntactic-category"><a href="Expressions.html#//appleref/swift/grammar/expression">expression</a></span>  <code>)</code> |  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/multiline-quoted-text-item">multiline-quoted-text-item</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/escaped-character"></a>escaped-character</span><span class="arrow"> → </span> <code>\0</code> |  <code>\\</code> |  <code>\t</code> |  <code>\n</code> |  <code>\r</code> |  <code>\&quot;</code> |  <code>\'</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/escaped-character"></a>escaped-character</span><span class="arrow"> → </span> <code>\u</code> <code>{</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/unicode-scalar-digits">unicode-scalar-digits</a></span>  <code>}</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/unicode-scalar-digits"></a>unicode-scalar-digits</span><span class="arrow"> → </span> Between one and eight hexadecimal digits</p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/escaped-newline"></a>escaped-newline</span><span class="arrow"> → </span> <code>\</code> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/whitespace">whitespace</a></span> <sub>opt</sub> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/line-break">line-break</a></span> </p></div></div></div>
</div>
<div class="section" id="ID418">
<h2>Operators<a class="headerlink" href="LexicalStructure.html#ID418" title="Permalink to this headline"></a></h2>
<p>The Swift standard library defines a number of operators for your use, many of which are discussed in <a class="reference internal" href="../LanguageGuide/BasicOperators.html"><span class="doc">Basic Operators</span></a> and <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html"><span class="doc">Advanced Operators</span></a>. The present section describes which characters can be used to define custom operators.</p>
<p>Custom operators can begin with one of the ASCII characters <code class="docutils literal"><span class="pre">/</span></code>, <code class="docutils literal"><span class="pre">=</span></code>, <code class="docutils literal"><span class="pre">-</span></code>, <code class="docutils literal"><span class="pre">+</span></code>, <code class="docutils literal"><span class="pre">!</span></code>, <code class="docutils literal"><span class="pre">*</span></code>, <code class="docutils literal"><span class="pre">%</span></code>, <code class="docutils literal"><span class="pre">&lt;</span></code>, <code class="docutils literal"><span class="pre">&gt;</span></code>, <code class="docutils literal"><span class="pre">&amp;</span></code>, <code class="docutils literal"><span class="pre">|</span></code>, <code class="docutils literal"><span class="pre">^</span></code>, <code class="docutils literal"><span class="pre">?</span></code>, or <code class="docutils literal"><span class="pre">~</span></code>, or one of the Unicode characters defined in the grammar below (which include characters from the <em>Mathematical Operators</em>, <em>Miscellaneous Symbols</em>, and <em>Dingbats</em> Unicode blocks, among others). After the first character, combining Unicode characters are also allowed.</p>
<p>You can also define custom operators that begin with a dot (<code class="docutils literal"><span class="pre">.</span></code>). These operators can contain additional dots. For example, <code class="docutils literal"><span class="pre">.+.</span></code> is treated as a single operator. If an operator doesn’t begin with a dot, it can’t contain a dot elsewhere. For example, <code class="docutils literal"><span class="pre">+.+</span></code> is treated as the <code class="docutils literal"><span class="pre">+</span></code> operator followed by the <code class="docutils literal"><span class="pre">.+</span></code> operator.</p>
<p>Although you can define custom operators that contain a question mark (<code class="docutils literal"><span class="pre">?</span></code>), they can’t consist of a single question mark character only. Additionally, although operators can contain an exclamation mark (<code class="docutils literal"><span class="pre">!</span></code>), postfix operators can’t begin with either a question mark or an exclamation mark.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The tokens <code class="docutils literal"><span class="pre">=</span></code>, <code class="docutils literal"><span class="pre">-&gt;</span></code>, <code class="docutils literal"><span class="pre">//</span></code>, <code class="docutils literal"><span class="pre">/*</span></code>, <code class="docutils literal"><span class="pre">*/</span></code>, <code class="docutils literal"><span class="pre">.</span></code>, the prefix operators <code class="docutils literal"><span class="pre">&lt;</span></code>, <code class="docutils literal"><span class="pre">&amp;</span></code>, and <code class="docutils literal"><span class="pre">?</span></code>, the infix operator <code class="docutils literal"><span class="pre">?</span></code>, and the postfix operators <code class="docutils literal"><span class="pre">&gt;</span></code>, <code class="docutils literal"><span class="pre">!</span></code>, and <code class="docutils literal"><span class="pre">?</span></code> are reserved. These tokens can’t be overloaded, nor can they be used as custom operators.</p>
</div>
<p>The whitespace around an operator is used to determine whether an operator is used as a prefix operator, a postfix operator, or a binary operator. This behavior is summarized in the following rules:</p>
<ul class="simple">
<li>If an operator has whitespace around both sides or around neither side, it’s treated as a binary operator. As an example, the <code class="docutils literal"><span class="pre">+++</span></code> operator in <code class="docutils literal"><span class="pre">a+++b</span></code> and <code class="docutils literal"><span class="pre">a</span> <span class="pre">+++</span> <span class="pre">b</span></code> is treated as a binary operator.</li>
<li>If an operator has whitespace on the left side only, it’s treated as a prefix unary operator. As an example, the <code class="docutils literal"><span class="pre">+++</span></code> operator in <code class="docutils literal"><span class="pre">a</span> <span class="pre">+++b</span></code> is treated as a prefix unary operator.</li>
<li>If an operator has whitespace on the right side only, it’s treated as a postfix unary operator. As an example, the <code class="docutils literal"><span class="pre">+++</span></code> operator in <code class="docutils literal"><span class="pre">a+++</span> <span class="pre">b</span></code> is treated as a postfix unary operator.</li>
<li>If an operator has no whitespace on the left but is followed immediately by a dot (<code class="docutils literal"><span class="pre">.</span></code>), it’s treated as a postfix unary operator. As an example, the <code class="docutils literal"><span class="pre">+++</span></code> operator in <code class="docutils literal"><span class="pre">a+++.b</span></code> is treated as a postfix unary operator (<code class="docutils literal"><span class="pre">a+++</span> <span class="pre">.b</span></code> rather than <code class="docutils literal"><span class="pre">a</span> <span class="pre">+++</span> <span class="pre">.b</span></code>).</li>
</ul>
<p>For the purposes of these rules, the characters <code class="docutils literal"><span class="pre">(</span></code>, <code class="docutils literal"><span class="pre">[</span></code>, and <code class="docutils literal"><span class="pre">{</span></code> before an operator, the characters <code class="docutils literal"><span class="pre">)</span></code>, <code class="docutils literal"><span class="pre">]</span></code>, and <code class="docutils literal"><span class="pre">}</span></code> after an operator, and the characters <code class="docutils literal"><span class="pre">,</span></code>, <code class="docutils literal"><span class="pre">;</span></code>, and <code class="docutils literal"><span class="pre">:</span></code> are also considered whitespace.</p>
<p>There’s one caveat to the rules above. If the <code class="docutils literal"><span class="pre">!</span></code> or <code class="docutils literal"><span class="pre">?</span></code> predefined operator has no whitespace on the left, it’s treated as a postfix operator, regardless of whether it has whitespace on the right. To use the <code class="docutils literal"><span class="pre">?</span></code> as the optional-chaining operator, it must not have whitespace on the left. To use it in the ternary conditional (<code class="docutils literal"><span class="pre">?</span></code> <code class="docutils literal"><span class="pre">:</span></code>) operator, it must have whitespace around both sides.</p>
<p>In certain constructs, operators with a leading <code class="docutils literal"><span class="pre">&lt;</span></code> or <code class="docutils literal"><span class="pre">&gt;</span></code> may be split into two or more tokens. The remainder is treated the same way and may be split again. As a result, there’s no need to use whitespace to disambiguate between the closing <code class="docutils literal"><span class="pre">&gt;</span></code> characters in constructs like <code class="docutils literal"><span class="pre">Dictionary&lt;String,</span> <span class="pre">Array&lt;Int&gt;&gt;</span></code>. In this example, the closing <code class="docutils literal"><span class="pre">&gt;</span></code> characters are not treated as a single token that may then be misinterpreted as a bit shift <code class="docutils literal"><span class="pre">&gt;&gt;</span></code> operator.</p>
<p>To learn how to define new, custom operators, see <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID46"><span class="std std-ref">Custom Operators</span></a> and <a class="reference internal" href="Declarations.html#ID380"><span class="std std-ref">Operator Declaration</span></a>. To learn how to overload existing operators, see <a class="reference internal" href="../LanguageGuide/AdvancedOperators.html#ID42"><span class="std std-ref">Operator Methods</span></a>.</p>
<div class="admonition grammar"><p class="first admonition-title">Grammar of operators</p><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator"></a>operator</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/operator-head">operator-head</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/operator-characters">operator-characters</a></span> <sub>opt</sub></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator"></a>operator</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/dot-operator-head">dot-operator-head</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/dot-operator-characters">dot-operator-characters</a></span> </p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> <code>/</code> |  <code>=</code> |  <code>-</code> |  <code>+</code> |  <code>!</code> |  <code>*</code> |  <code>%</code> |  <code>&lt;</code> |  <code>&gt;</code> |  <code>&amp;</code> |  <code>|</code> |  <code>^</code> |  <code>~</code> |  <code>?</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+00A1–U+00A7</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+00A9 or U+00AB</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+00AC or U+00AE</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+00B0–U+00B1, U+00B6, U+00BB, U+00BF, U+00D7, or U+00F7</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+2016–U+2017 or U+2020–U+2027</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+2030–U+203E</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+2041–U+2053</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+2055–U+205E</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+2190–U+23FF</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+2500–U+2775</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+2794–U+2BFF</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+2E00–U+2E7F</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+3001–U+3003</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-head"></a>operator-head</span><span class="arrow"> → </span> U+3008–U+3030</p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-character"></a>operator-character</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/operator-head">operator-head</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-character"></a>operator-character</span><span class="arrow"> → </span> U+0300–U+036F</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-character"></a>operator-character</span><span class="arrow"> → </span> U+1DC0–U+1DFF</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-character"></a>operator-character</span><span class="arrow"> → </span> U+20D0–U+20FF</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-character"></a>operator-character</span><span class="arrow"> → </span> U+FE00–U+FE0F</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-character"></a>operator-character</span><span class="arrow"> → </span> U+FE20–U+FE2F</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-character"></a>operator-character</span><span class="arrow"> → </span> U+E0100–U+E01EF</p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/operator-characters"></a>operator-characters</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/operator-character">operator-character</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/operator-characters">operator-characters</a></span> <sub>opt</sub></p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/dot-operator-head"></a>dot-operator-head</span><span class="arrow"> → </span> <code>.</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/dot-operator-character"></a>dot-operator-character</span><span class="arrow"> → </span> <code>.</code> |  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/operator-character">operator-character</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/dot-operator-characters"></a>dot-operator-characters</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/dot-operator-character">dot-operator-character</a></span>  <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/dot-operator-characters">dot-operator-characters</a></span> <sub>opt</sub></p></div><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/binary-operator"></a>binary-operator</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/operator">operator</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/prefix-operator"></a>prefix-operator</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/operator">operator</a></span> </p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/postfix-operator"></a>postfix-operator</span><span class="arrow"> → </span> <span class="syntactic-category"><a href="LexicalStructure.html#//appleref/swift/grammar/operator">operator</a></span> </p></div></div></div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="AboutTheLanguageReference.html">About the Language Reference</a></p>
        <p class="next"><a href="Types.html">Types</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple's beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  </body>
</html>
